"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.handleResponse = exports.getPathOrExtractPathFromObject = exports.extractData = void 0;

var _axios = _interopRequireDefault(require("axios"));

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const extractData = (v, path) => {
  let label;
  let value;

  if (typeof v === 'object' && v !== null) {
    label = (0, _lodash.get)(v, path);
    value = (0, _lodash.get)(v, 'id', label);
  } else {
    label = v;
    value = v;
  }

  return {
    label,
    value,
    ...v
  };
};

exports.extractData = extractData;

const getPathOrExtractPathFromObject = (useGet, path) => target => useGet ? (0, _lodash.get)(target, path) : extractData(target, path);

exports.getPathOrExtractPathFromObject = getPathOrExtractPathFromObject;

const handleResponse = (key, nestedKey, returnAsNonExtractedData = false) => ({
  data
}) => nestedKey ? (0, _lodash.get)(data, key, []).map(getPathOrExtractPathFromObject(returnAsNonExtractedData, nestedKey)) : (0, _lodash.get)(data, key, []);

exports.handleResponse = handleResponse;

var _default = (url, ...rest) => _axios.default.get(url).then(handleResponse(...rest)).catch(() => {
  return [];
});

exports.default = _default;